Log::Metadata - Crystal 0.35.1

# class Log::Metadata

- Log::Metadata
- Reference
- Object

##
Overview

Immutable structured metadata information for logging.

See `Log.context`, `Log.context=`, `Log::Context#clear`, `Log::Context#set`, `Log.with_context`, and `Log::Emitter`.

NOTE If you'd like to format the context as JSON, remember to `require "log/json"`.

##
Included Modules

- Enumerable({Symbol, Log::Metadata::Value})

##
Defined in:

##
Constructors

- .new(parent : Metadata? = nil, entries : NamedTuple | Hash = NamedTuple.new)

##
Class Method Summary

- .build(value : NamedTuple | Hash)

  Returns a `Metadata` with the information of the argument.

- .build(value : Metadata)

  Returns a `Metadata` with the information of the argument.

- .empty : Log::Metadata

  Returns an empty `Log::Metadata`.

##
Instance Method Summary

- #==(other : Metadata)
- #[](key : Symbol) : Value
- #[]?(key : Symbol) : Value?
- #each(& : Tuple(Symbol, Value) -> )

  Must yield this collection's elements to the block.

- #empty?

  Returns `true` if `self` is empty, `false` otherwise.

- #extend(other : NamedTuple | Hash) : Metadata

  Returns a `Log::Metadata` with all the entries of self and other.

- #fetch(key, &)
- #to_s(io : IO) : Nil

  Appends a short String representation of this object which includes its class name and its object address.

### Instance methods inherited from module `Enumerable({Symbol, Log::Metadata::Value})`

all?(&)
all?(pattern)
all? all?, any?(&)
any?(pattern)
any? any?, chunks(&block : {Symbol, Log::Metadata::Value} -> U) forall U chunks, compact_map(&) compact_map, count(&)
count(item) count, cycle(&)
cycle(n, &) cycle, each(&block : {Symbol, Log::Metadata::Value} -> _) each, each_cons(count : Int, reuse = false, &) each_cons, each_cons_pair(& : {Symbol, Log::Metadata::Value}, {Symbol, Log::Metadata::Value} -> _) : Nil each_cons_pair, each_slice(count : Int, reuse = false, &) each_slice, each_with_index(offset = 0, &) each_with_index, each_with_object(obj, &) each_with_object, empty? empty?, find(if_none = nil, &) find, first(&)
first(count : Int)
first first, first? first?, flat_map(&block : {Symbol, Log::Metadata::Value} -> Array(U) | Iterator(U) | U) forall U flat_map, grep(pattern) grep, group_by(&block : {Symbol, Log::Metadata::Value} -> U) forall U group_by, in_groups_of(size : Int, filled_up_with : U = nil) forall U
in_groups_of(size : Int, filled_up_with : U = nil, reuse = false, &) forall U in_groups_of, includes?(obj) includes?, index(&)
index(obj) index, index_by(&block : {Symbol, Log::Metadata::Value} -> U) forall U index_by, join(separator = "", & : {Symbol, Log::Metadata::Value} -> )
join(separator, io : IO, &)
join(io : IO, separator = "", & : {Symbol, Log::Metadata::Value}, IO -> )
join(separator = "")
join(separator, io : IO)
join(io : IO, separator = "") join, map(&block : {Symbol, Log::Metadata::Value} -> U) forall U map, map_with_index(offset = 0, &block : {Symbol, Log::Metadata::Value}, Int32 -> U) forall U map_with_index, max max, max? max?, max_by(&block : {Symbol, Log::Metadata::Value} -> U) forall U max_by, max_by?(&block : {Symbol, Log::Metadata::Value} -> U) forall U max_by?, max_of(&block : {Symbol, Log::Metadata::Value} -> U) forall U max_of, max_of?(&block : {Symbol, Log::Metadata::Value} -> U) forall U max_of?, min min, min? min?, min_by(&block : {Symbol, Log::Metadata::Value} -> U) forall U min_by, min_by?(&block : {Symbol, Log::Metadata::Value} -> U) forall U min_by?, min_of(&block : {Symbol, Log::Metadata::Value} -> U) forall U min_of, min_of?(&block : {Symbol, Log::Metadata::Value} -> U) forall U min_of?, minmax minmax, minmax? minmax?, minmax_by(&block : {Symbol, Log::Metadata::Value} -> U) forall U minmax_by, minmax_by?(&block : {Symbol, Log::Metadata::Value} -> U) forall U minmax_by?, minmax_of(&block : {Symbol, Log::Metadata::Value} -> U) forall U minmax_of, minmax_of?(&block : {Symbol, Log::Metadata::Value} -> U) forall U minmax_of?, none?
none?(pattern)
none?(&) none?, one?(&)
one?(pattern)
one? one?, partition(&) partition, product
product(initial : Number)
product(initial : Number, &)
product(&) product, reduce(memo, &)
reduce(&) reduce, reduce?(&) reduce?, reject(pattern)
reject(type : U.class) forall U
reject(&block : {Symbol, Log::Metadata::Value} -> ) reject, select(pattern)
select(type : U.class) forall U
select(&block : {Symbol, Log::Metadata::Value} -> ) select, size size, skip(count : Int) skip, skip_while(&) skip_while, sum(initial)
sum
sum(initial, &)
sum(&) sum, take_while(&) take_while, tally : Hash({Symbol, Log::Metadata::Value}, Int32) tally, to_a to_a, to_h
to_h(&block : {Symbol, Log::Metadata::Value} -> Tuple(K, V)) forall K, V to_h, to_set to_set, zip(*others : Indexable | Iterable | Iterator, &)
zip(*others : Indexable | Iterable | Iterator) zip, zip?(*others : Indexable | Iterable | Iterator, &)
zip?(*others : Indexable | Iterable | Iterator) zip?

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(*values : Object) : Bool
in?(collection) : Bool in?, inspect : String
inspect(io : IO) : Nil inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(io : IO, indent : String = " ")
to_pretty_json(indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(parent : Metadata? = nil, entries : NamedTuple | Hash = NamedTuple.new) #

##
Class Method Detail

def self.build(value : NamedTuple | Hash) #

Returns a `Metadata` with the information of the argument. Used to handle `Log::Context#set` and `Log#Emitter.emit` overloads.

def self.build(value : Metadata) #

Returns a `Metadata` with the information of the argument. Used to handle `Log::Context#set` and `Log#Emitter.emit` overloads.

def self.empty : Log::Metadata #

Returns an empty `Log::Metadata`.

NOTE Since `Log::Metadata` is immutable, it's safe to share this instance.

##
Instance Method Detail

def ==(other : Metadata) #
def [](key : Symbol) : Value #
def []?(key : Symbol) : Value? #
def each(& : Tuple(Symbol, Value) -> ) #
Description copied from module Enumerable({Symbol, Log::Metadata::Value})

Must yield this collection's elements to the block.

def empty? #
Description copied from module Enumerable({Symbol, Log::Metadata::Value})

Returns `true` if `self` is empty, `false` otherwise.

    ([] of Int32).empty? # => true
    ([1]).empty?         # => false

def extend(other : NamedTuple | Hash) : Metadata #

Returns a `Log::Metadata` with all the entries of self and other. If a key is defined in both, the values in other are used.

def fetch(key, &) #
def to_s(io : IO) : Nil #
Description copied from class Reference

Appends a short String representation of this object which includes its class name and its object address.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).to_s # => #<Person:0x10a199f20>